// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;

/**
 * Oberklasse aller Gespenster
 * @author Albert Wiedemann @version 1.0
 */
public abstract class Gespenst extends Hindernis
{
    /* x-Startposition merken*/
    protected int xStart;
    /* y-Startposition merken*/
    protected int yStart;

    /**
     * Der Konstruktor legt Position, Größe und Farbe fest @param x x-Koordinate des Rechtecks @param y y-Koordinate des Rechtecks @param rahmen das Rahmenobjekt des Spiels
     */
    protected Gespenst(int x, int y, Rahmen rahmen)
    {
        super(x , y , rahmen);
        xStart = x;
        yStart = y;
    }

    /**
     * erzeugt die Figur aller Gespenster @param farbe die Farbe der Figur
     */
    protected void FigurErzeugen(String farbe)
    {
        EigeneFigurLöschen ( );
        FigurteilFestlegenEllipse ( - 15 , - 50 , 30 , 30 , farbe );
        FigurteilFestlegenDreieck ( - 25 , 45 , 0 , - 50 , 25 , 45 , farbe );
        FigurteilFestlegenRechteck ( - 15 , - 35 , 30 , 80 , farbe );
        FigurteilFestlegenEllipse ( - 25 , 40 , 10 , 10 , farbe );
        FigurteilFestlegenEllipse ( - 15 , 40 , 10 , 10 , farbe );
        FigurteilFestlegenEllipse ( - 5 , 40 , 10 , 10 , farbe );
        FigurteilFestlegenEllipse ( 5 , 40 , 10 , 10 , farbe );
        FigurteilFestlegenEllipse ( 15 , 40 , 10 , 10 , farbe );
        FigurteilFestlegenEllipse ( - 11 , - 35 , 9 , 9 , "schwarz" );
        FigurteilFestlegenEllipse ( 2 , - 35 , 9 , 9 , "schwarz" );
    }

    /**
     * Das Gespenst @param monster das Monster
     */
    protected void Reagieren(Monster monster)
    {
        if (Berührt ( monster )) {
            monster . LebenNehmen ( );
            AufStartpositionSetzen ( );
        }
    }

    /**
     * Setzt das Gespenst auf die Startposition zurück
     */
    protected void AufStartpositionSetzen()
    {
        PositionSetzen ( xStart * rahmen . basisGröße + rahmen . basisGröße / 2 , yStart * rahmen . basisGröße + rahmen . basisGröße / 2 );
    }

    /**
     * Berechnet den Kästchenabstand der gegebenen Koordinaten zum Monster @param x x-Koordinate des Punktes, zu dem der Abstand berechnet wird @param y y-Koordinate des Punktes, zu dem der Abstand berechnet wird @return Kästchenabstand
     */
    protected int AbstandGeben(int x, int y)
    {
        return ( Math . abs ( x - rahmen . MonsterGeben ( ) . XPositionGeben ( ) ) + Math . abs ( y - rahmen . MonsterGeben ( ) . YPositionGeben ( ) ) ) / rahmen . basisGröße;
    }

    /**
     * Muss in der Unterklasse überschreiben werden
     */
    abstract void Bewegen();

    /**
     * Das Gespenst geht
     */
    protected void AktionAusführen()
    {
        Bewegen ( );
        if (Berührt ( rahmen . MonsterGeben ( ) )) {
            rahmen . MonsterGeben ( ) . LebenNehmen ( );
            AufStartpositionSetzen ( );
        }
    }
}
