
import java.util.*;
/**
 * Verwaltet die Animationselemente
 *
 * @author Albert Wiedemann
 * @version 1.0
 */
class Animation
{
    /** Die Elemente */
    private ArrayList<AnimationsElement> elemente;

    /**
     * Legt ein leeres Feld mit Elementen an.
     */
    Animation()
    {
        elemente = new ArrayList<AnimationsElement>();
    }

    /**
     * Fügt dem Feld der Animationselemente ein neues Element hinzu.
     * @param e das neue Animationselement
     */
    void ElementEinfügen(AnimationsElement e)
    {
        elemente.add(e);
    }
    
    /**
     * Führt die Bewegung für alle Elemente aus.
     */
    void Tanzen()
    {
        for (AnimationsElement e: elemente)
        {
            e.Tanzen();
        }
    }
    
    /**
     * Führt die Umfärbung für alle Elemente aus.
     */
    void Umfärben()
    {
        for (AnimationsElement e: elemente)
        {
            e.Umfärben();
        }
    }
}
