// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;
import greenfoot.*;

/**
 * Verwaltet das Hintergrundfenster
 * @author Albert Wiedemann @version 1.0
 */
public class HintergrundFenster
{
    /* Anzeigegröße für eine Rasterkachel*/
    private int rasterGröße;
    /* Höhe des Anzeigefensters*/
    private int höheFenster;
    /* Breite des Anzeigefensters*/
    private int breiteFenster;
    /* Die eigentliche Malfläche, wird als Hintergrundbild für die Greenfoodwelt verwendet.*/
    private GreenfootImage malfläche;
    /* Die Welt, in der das Szenario spielt.*/
    private GrafikWelt welt;
    /* Wenn wahr, werden die Punkte angezeigt*/
    private boolean wertGesetzt;
    /* der anzuzegende Punktestand*/
    private int punkte;
    /* Wenn wahr, wird die Endemeldung angezeigt*/
    private boolean endemeldungGesetzt;
    /* Die Endemeldung*/
    private String endeMeldung;
    /* Wenn wahr, wird die Sonderanzeige angezeigt*/
    private boolean sonderanzeigeGesetzt;
    /* Die Sondermeldung*/
    private String sonderAnzeige;

    /**
     * Erstellt das Offscreenimage und trägt es ein. @param breite Fensterbreite @param höhe Fensterhöhe @param raster Rastergröße @param welt die Grafikwelt
     */
    protected HintergrundFenster(int breite, int höhe, int raster, GrafikWelt welt)
    {
        rasterGröße = raster;
        breiteFenster = breite;
        höheFenster = höhe;
        wertGesetzt = false;
        punkte = 0;
        endemeldungGesetzt = false;
        endeMeldung = "";
        sonderanzeigeGesetzt = false;
        sonderAnzeige = "";
        malfläche = new GreenfootImage ( breite , höhe );
        malfläche . setColor ( new greenfoot . Color ( 240 , 240 , 240 ) );
        malfläche . fillRect ( 0 , 0 , malfläche . getWidth ( ) - 1 , malfläche . getHeight ( ) - 1 );
        this . welt = welt;
        welt . setBackground ( malfläche );
        welt . repaint ( );
    }

    /**
     * Erstellt den Inhalt des Hintergrundbildes neu.
     */
    protected void MalflächeAktualisieren()
    {
        malfläche . clear ( );
        malfläche . setColor ( new greenfoot . Color ( 240 , 240 , 240 ) );
        malfläche . fillRect ( 0 , 0 , malfläche . getWidth ( ) - 1 , malfläche . getHeight ( ) - 1 );
        Graphics g = malfläche . getAwtImage ( ) . createGraphics ( );
        g . setColor ( java . awt . Color . lightGray );
        int i = 1;
        while (i <= höheFenster / ( rasterGröße * 2 )) {
            g . drawLine ( 0 , höheFenster / 2 + i * rasterGröße , breiteFenster - 1 , höheFenster / 2 + i * rasterGröße );
            g . drawLine ( 0 , höheFenster / 2 - i * rasterGröße , breiteFenster - 1 , höheFenster / 2 - i * rasterGröße );
            i = i + 1;
        }
        int i = 1;
        while (i <= breiteFenster / ( rasterGröße * 2 )) {
            g . drawLine ( breiteFenster / 2 + i * rasterGröße , 0 , breiteFenster / 2 + i * rasterGröße , höheFenster - 1 );
            g . drawLine ( breiteFenster / 2 - i * rasterGröße , 0 , breiteFenster / 2 - i * rasterGröße , höheFenster - 1 );
            i = i + 1;
        }
        g . setColor ( java . awt . Color . black );
        g . drawLine ( 0 , höheFenster / 2 , breiteFenster - 1 , höheFenster / 2 );
        g . drawLine ( breiteFenster / 2 , 0 , breiteFenster / 2 , höheFenster - 1 );
        g . setColor ( java . awt . Color . lightGray );
        int[] xKoord = { 0 , breiteFenster , breiteFenster , 0 , 0 , rasterGröße , rasterGröße , breiteFenster - rasterGröße , breiteFenster - rasterGröße , rasterGröße , 0 };
        int[] yKoord = { 0 , 0 , höheFenster , höheFenster , 0 , rasterGröße , höheFenster - rasterGröße , höheFenster - rasterGröße , rasterGröße , rasterGröße , 0 };
        g . fillPolygon ( xKoord , yKoord , xKoord . length );
        if (wertGesetzt) {
            java.awt.Font font = new java . awt . Font ( "Helvetica" , java . awt . Font . BOLD , 14 );
            g . setFont ( font );
            g . setColor ( java . awt . Color . blue );
            g . drawString ( "Punkte: " + punkte , 4 , 3 * rasterGröße / 4 );
        }
        if (endemeldungGesetzt) {
            java.awt.Font font = new java . awt . Font ( "Helvetica" , java . awt . Font . BOLD , 24 );
            g . setFont ( font );
            g . setColor ( java . awt . Color . red );
            g . drawString ( endeMeldung , rasterGröße * 2 , höheFenster / 4 );
        }
        welt . repaint ( );
    }

    /**
     * Setzt den Punktestand für die Anzeige @param punkte der anzuzeigende Punktestand
     */
    protected void PunkteSetzen(int punkte)
    {
        this . punkte = punkte;
        wertGesetzt = true;
        MalflächeAktualisieren ( );
    }

    /**
     * Setzt die Endemeldung für die Anzeige @param die anzuzeigende Endemeldung
     */
    protected void EndemeldungSetzen(String meldung)
    {
        endeMeldung = meldung;
        endemeldungGesetzt = true;
        MalflächeAktualisieren ( );
    }

    /**
     * Setzt die Sondermeldung für die Anzeige @param die anzuzeigende Sondermeldung
     */
    protected void SonderanzeigeSetzen(String meldung)
    {
        sonderAnzeige = meldung;
        sonderanzeigeGesetzt = ! "" . equals ( meldung );
        MalflächeAktualisieren ( );
    }
}
