// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import java.util.ArrayList;

/**
 * Die Verwaltungsklasse der Schlange.
 * @author Albert Wiedemann @version 1.0
 */
public class Schlange
{
    /* Darstellung des Kopfs.*/
    private KopfSymbol kopf;
    /* Darstellung des Rumpfs Darstellung des Rumpfs*/
    private ArrayList<RumpfSymbol> rumpf;

    /**
     * Legt die Schlange an und stellt Anfangsposition und -bewgungsrichtung ein. @param x: x-Koordinate der Startposition des Schlangenkopfs @param y: y-Koordinate der Startposition des Schlangenkopfs @param richtung: Startrichtung des Schlangenkopfs
     */
    protected Schlange(int x, int y, char richtung)
    {
        kopf = new KopfSymbol ( );
        GrafikWelt . dieWelt . addObject ( kopf , 0 , 0 );
        kopf . AusrichtungSetzen ( richtung );
        kopf . PositionSetzen ( x , y );
        rumpf = new ArrayList < RumpfSymbol > ( );
        for (int i = 0;i <= 4;i++) {
            rumpf . add ( new RumpfSymbol ( ) );
            GrafikWelt . dieWelt . addObject ( rumpf . get ( i ) , 0 , 0 );
        }
        switch (richtung) {
            case 'O' : {
                int i = 0;
                while (i < rumpf . size ( )) {
                    rumpf . get ( i ) . PositionSetzen ( x - ( rumpf . size ( ) - i ) , y );
                    i = i + 1;
                }
                break;
            }
            case 'N' : {
                int i = 0;
                while (i < rumpf . size ( )) {
                    rumpf . get ( i ) . PositionSetzen ( x , y + ( rumpf . size ( ) - i ) );
                    i = i + 1;
                }
                break;
            }
            case 'W' : {
                int i = 0;
                while (i < rumpf . size ( )) {
                    rumpf . get ( i ) . PositionSetzen ( x + ( rumpf . size ( ) - i ) , y );
                    i = i + 1;
                }
                break;
            }
            case 'S' : {
                int i = 0;
                while (i < rumpf . size ( )) {
                    rumpf . get ( i ) . PositionSetzen ( x , y - ( rumpf . size ( ) - i ) );
                    i = i + 1;
                }
                break;
            }
        }
    }

    /**
     * Bewegt die Schlange ein Feld in der eingestellten Richtung. @param verlängern wenn wahr, wird das letzte Rumpfelement nicht entfernt.
     */
    protected void Bewegen(boolean verlängern)
    {
        int x;
        int xalt;
        int y;
        int yalt;
        x = kopf . XPositionGeben ( );
        y = kopf . YPositionGeben ( );
        xalt = x;
        yalt = y;
        switch (kopf . AusrichtungGeben ( )) {
            case 'O' : {
                x = x + 1;
                break;
            }
            case 'N' : {
                y = y - 1;
                break;
            }
            case 'W' : {
                x = x - 1;
                break;
            }
            case 'S' : {
                y = y + 1;
                break;
            }
        }
        kopf . PositionSetzen ( x , y );
        if (! verlängern) {
            rumpf . get ( 0 ) . Entfernen ( );
            rumpf . remove ( 0 );
        }
        rumpf . add ( new RumpfSymbol ( ) );
        GrafikWelt . dieWelt . addObject ( rumpf . get ( rumpf . size ( ) - 1 ) , 0 , 0 );
        rumpf . get ( rumpf . size ( ) - 1 ) . PositionSetzen ( xalt , yalt );
    }

    /**
     * Setzt die Bewegunsrichtung der Schlange. @param richtungNeu (neue) Bewegungsrichtung
     */
    protected void RichtungSetzen(char richtungNeu)
    {
        kopf . AusrichtungSetzen ( richtungNeu );
    }

    /**
     * Gibt die x-Position des Schlangenkopfs zurück. @return x-Position des Schlangenkopfs
     */
    protected int XPositionGeben()
    {
        return kopf . XPositionGeben ( );
    }

    /**
     * Gibt die y-Position des Schlangenkopfs zurück. @return y-Position des Schlangenkopfs
     */
    protected int YPositionGeben()
    {
        return kopf . YPositionGeben ( );
    }

    /**
     * Prueft ob der Schlangenkopf auf der Position eines Rumpfsymbols ist, d.h.sich die Schlange selbst gebissen hat. return wahr, wenn der Kopf im Rumpf liegt.
     */
    protected boolean KopfInRumpf()
    {
        return PunktInRumpf ( kopf . XPositionGeben ( ) , kopf . YPositionGeben ( ) );
    }

    /**
     * Prueft ob der angegebe Punkt auf der Position eines Rumpfsymbols ist. @return wahr, wenn der Punkt zu einem Rumpfelement gehört.
     */
    protected boolean PunktInRumpf(int x, int y)
    {
        for (final RumpfSymbol r : rumpf) {
            if (( x == r . XPositionGeben ( ) ) && ( y == r . YPositionGeben ( ) )) {
                return true;
            }
        }
        return false;
    }
}
