// WARNING: This file is auto-generated and any changes to it will be overwritten
import lang.stride.*;
import greenfoot.*;
import java.awt.event.*;
import java.util.*;

/**
 * Rahmenklasse des Spiels
 * @author Albert Wiedemann @version 1.0
 */
public class Spiel extends GrafikWelt
{
    /* (World, Actor, GreenfootImage, Greenfoot and MouseInfo)*/
    /* Die Schlange.*/
    protected Schlange schlange;
    /* Der Punktestand*/
    protected int punkte;
    /* Verlängerungsintervall*/
    private static final int maxSchritte = 10;
    /* Aktuelle Schrittzahl für Verlängerung*/
    private int aktSchritte;
    /* Zufallsgeneror für das Spiel*/
    protected Random zzGenerator;
    /* Restschritte für Sonderverlängerung der Schlange.*/
    private int sonderZähler;
    /* Restschritte für Bremsen*/
    private int bremsZähler;
    /* Die Sonderfelder*/
    private ArrayList<SonderFeld> sonderfelder;

    /**
     * Baut die Basiselemente auf.
     */
    public Spiel()
    {
        char richtung;
        int xStart;
        int yStart;
        zzGenerator = new Random ( );
        sonderfelder = new ArrayList < SonderFeld > ( );
        switch (zzGenerator . nextInt ( 4 )) {
            case 0 : {
                richtung = 'O';
                break;
            }
            case 1 : {
                richtung = 'N';
                break;
            }
            case 2 : {
                richtung = 'W';
                break;
            }
            default : {
                richtung = 'S';
                break;
            }
        }
        xStart = - 5 + zzGenerator . nextInt ( 10 );
        yStart = - 4 + zzGenerator . nextInt ( 8 );
        schlange = new Schlange ( xStart , yStart , richtung );
        punkte = 0;
        aktSchritte = maxSchritte;
        sonderZähler = 0;
        bremsZähler = 0;
        Greenfoot . setSpeed ( 25 );
        sonderfelder . add ( new Apfel ( this ) );
        for (int i = 1;i <= 5;i++) {
            sonderfelder . add ( new Pilz ( this ) );
        }
        for (int i = 1;i <= 5;i++) {
            sonderfelder . add ( new Minus ( this ) );
        }
    }

    /**
     * Erzeugt eine zufällige x-Koordinate auf den Spielfeld. @return zufällige x-Koordinate
     */
    protected int XKoordinateZufälligGeben()
    {
        return zzGenerator . nextInt ( XMaxGeben ( ) - XMinGeben ( ) + 1 ) + XMinGeben ( );
    }

    /**
     * Erzeugt eine zufällige y-Koordinate auf den Spielfeld. @return zufällige y-Koordinate
     */
    protected int YKoordinateZufälligGeben()
    {
        return zzGenerator . nextInt ( YMaxGeben ( ) - YMinGeben ( ) + 1 ) + YMinGeben ( );
    }

    /**
     * Testet, ob eine gegebene Position noch frei ist. @param x x-Koordinate der Position @param y y-Koordinate der Position @return wahr, wenn die gegebene Position weder von der Schlange noch anderen Symbolen belegt ist.
     */
    protected boolean IstFrei(int x, int y)
    {
        for (final SonderFeld s : sonderfelder) {
            if (( s != null ) && ( s . XPositionGeben ( ) == x ) && ( s . YPositionGeben ( ) == y )) {
                return false;
            }
        }
        if (( schlange . XPositionGeben ( ) == x ) && ( schlange . YPositionGeben ( ) == y )) {
            return false;
        }
        if (schlange . PunktInRumpf ( x , y )) {
            return false;
        }
        return true;
    }

    /**
     * Verändert den Punktestand um den angegebenen Wert. @param delta die Punktestandsänderung
     */
    protected void PunkteÄndern(int delta)
    {
        punkte = punkte + delta;
    }

    /**
     * Startet bzw.verlängert das Sonderwachstum der Schlange.
     */
    protected void Sonderwachstum()
    {
        sonderZähler = sonderZähler + 10;
    }

    /**
     * Aktiviert die Verzögerung des Ablaufs.
     */
    protected void Bremsen()
    {
        bremsZähler = 100;
        Greenfoot . setSpeed ( 12 );
        SonderanzeigeSetzen ( "+" );
    }

    /**
     * Entfernt das angegebene Sonderfeldobjekt aus sonderfelder. @param was die zu entfernene Referenz
     */
    protected void Entfernen(SonderFeld was)
    {
        sonderfelder . remove ( was );
    }

    /**
     * Bewegt die Schlange.
     */
    protected void TaktImpulsAusführen()
    {
        if (( schlange . XPositionGeben ( ) <= XMaxGeben ( ) ) && ( schlange . XPositionGeben ( ) >= XMinGeben ( ) ) && ( schlange . YPositionGeben ( ) <= YMaxGeben ( ) ) && ( schlange . YPositionGeben ( ) >= YMinGeben ( ) ) && ! schlange . KopfInRumpf ( )) {
            aktSchritte = aktSchritte - 1;
            if (aktSchritte <= 0) {
                schlange . Bewegen ( true );
                aktSchritte = maxSchritte;
            }
            else if (sonderZähler > 0) {
                schlange . Bewegen ( true );
                sonderZähler = sonderZähler - 1;
            }
            else {
                schlange . Bewegen ( false );
            }
            punkte = punkte + 1;
            if (bremsZähler > 0) {
                if (bremsZähler == 1) {
                    Greenfoot . setSpeed ( 25 );
                    SonderanzeigeSetzen ( "" );
                }
                else if (bremsZähler == 10) {
                    SonderanzeigeSetzen ( "!" );
                }
                bremsZähler = bremsZähler - 1;
            }
            for (final SonderFeld s : ( ArrayList < SonderFeld > ) sonderfelder . clone ( )) {
                if (( s != null ) && ( schlange . XPositionGeben ( ) == s . XPositionGeben ( ) ) && ( schlange . YPositionGeben ( ) == s . YPositionGeben ( ) )) {
                    s . Aktion ( );
                }
            }
            PunkteSetzen ( punkte );
        }
        else {
            Greenfoot . stop ( );
            if (schlange . KopfInRumpf ( )) {
                EndemeldungSetzen ( "Game Over - Schlange hat sich selbst gebissen" );
            }
            else {
                EndemeldungSetzen ( "Game Over - Schlange über Spielfeldrand" );
            }
        }
    }

    /**
     * Wertet die Tasteneingaben aus. @param welche Tastencode
     */
    protected void TasteGedrückt(char welche)
    {
        switch (welche) {
            case 'S' : {
            }
            case 's' : {
                Greenfoot . start ( );
                break;
            }
            case 'P' : {
            }
            case 'p' : {
                Greenfoot . stop ( );
                break;
            }
            default : {
                /* System.out.println("Taste: " + (0 + (int) welche));*/
            }
        }
    }

    /**
     * Wertet die Sondertasten aus. @param welche Tastencode
     */
    protected void SonderTasteGedrückt(int welche)
    {
        switch (welche) {
            case KeyEvent . VK_DOWN : {
            }
            case KeyEvent . VK_KP_DOWN : {
                schlange . RichtungSetzen ( 'S' );
                break;
            }
            case KeyEvent . VK_LEFT : {
                schlange . RichtungSetzen ( 'W' );
                break;
            }
            case KeyEvent . VK_RIGHT : {
                schlange . RichtungSetzen ( 'O' );
                break;
            }
            case KeyEvent . VK_UP : {
                schlange . RichtungSetzen ( 'N' );
                break;
            }
            default : {
                /* System.out.println("Taste: " + (0 + (int) welche));*/
            }
        }
    }
}
